'///////////////////////////////////////////////////////////////////////////////////////////////////

										'Voltage Generator
										'By Lilith Washu

'///////////////////////////////////////////////////////////////////////////////////////////////////
$Device= m32			' ʹõĵƬ
$Stack = 64				
$Clock = 11.0592			    ' ʹõĵƬƵ
'$ShiftIn Data = PORTB.3, Clock = PORTB.4, Msb 
'$ShiftOut Data = PORTB.1, Clock = PORTB.2, Msb
$Baud = 19200,n,8,1
$1Wire = PORTD.6
$LeadChar="0", Format(2,6)

'************** Config the IO **************
' the Display Screen IO Connect
$Def IO_SCR_RST = PORTC.7
$Def IO_SCR_CSA = PORTC.6
$Def IO_SCR_CSB = PORTC.5
$Def IO_SCR_DoI = PORTC.4
$Def IO_SCR_RoW = PORTC.3
$Def IO_SCR_STB = PORTC.2
$Def IO_SCR_DAT = PORTA
' the Analog Board IO Connect
$Def IO_REG_STB = PORTB.0
$Def IO_REG_DAT = PORTB.1
$Def IO_REG_CLK = PORTB.2
$Def IO_ADC_CLK = PORTB.4
$Def IO_ADC_DAT = PINB.3
$Def IO_KEY_STB = PORTB.5
$Def IO_KEY_DAT = PINB.6
$Def IO_KEY_CLK = PORTB.7
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Constant 
'///////////////////////////////////////////////////////////////////////////////////////////////////
Const fMasterReference = 7.037772e+00'7.066997E+00		'LM399 Voltage Value	
Const fDACReference = 1.200000E+01			'DAC Voltage Reference Value
Const fDACLCenter = -5.00000E+00				'Slave DAC Default Output Voltage Value
Const fDACHCenter = 9.00000E+00
Const fDACGain = 1.000000E+06				'DAC Output buff Gain
Const fMResistance = 2.49E+02				'DAC Voltgae Compound Resistance, the Master
Const fSResistance = 1E+06					'DAC Voltgae Compound Resistance, the Slave
'Const Cubic = -3.566e-01
Const Quadratic = -1.8625e+00'-3.2425e+00				'No-line Error Adjuest Quadratic Coefficient	ϵ
Const Linear = 1.8443e+01'4.262e+01					'No-line Error Adjuest Linear Coefficient		һϵ
Const Constant = 1.1972e+01'-5.8295e+01				'No-line Error Adjuest Offset Coefficient		
Const fDacal = 1.006000e+00					'DAC Fullscale Error Adjuest Vale	
Const Synthesis = &b00000001				' Analog Switch = Synthesis Voltage Output		| DG412 Pin 
Const Reference = &b00000010   				' Analog Switch = Internal Reference(LM399)		| DG412 Pin 
Const ExternaIN = &b00000100				' Analog Switch = Externa Voltage Input			| DG412 Pin 
Const GndOffset = &b00001000				' Analog Switch = Auto Zero						| DG412 Pin  
'
'							7.015122
'	fDACReference = 1.000129E+01 @03292013 by n6581
'	fMasterReference = 7.015114E+00 @03292013 by n6581
'					 = 7.015082 Direct Test by n6581
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' String Variables
'///////////////////////////////////////////////////////////////////////////////////////////////////
Dim Ft1 As Flash Byte	' 
Dim Ft2 As Flash Byte	' 
Dim Charat As String *33' Ҫʾַ
Dim tTxt As String *15
Dim tm As String *7
Dim tCmd As String *4
Dim iCursors(8) As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Gen Variables
'///////////////////////////////////////////////////////////////////////////////////////////////////
Dim i As Byte	
Dim bUartset As Byte
Dim bUartlk As Byte
Dim bAdjuest As Byte
Dim bDigitaLoop As Byte 
Dim bRun As Byte
Dim bTrigcompleted As Byte
Dim bRefsource As Byte
Dim bRunacycle As Byte

Dim iErrlimit As Byte
Dim bErrlimit As Byte
Dim wErrlimit As Word

Dim bSregister As Byte
Dim iSmlen As Byte		
Dim iSmsetp As Byte
Dim iBusystp As Byte
Dim iTrd As Byte
Dim iDraw As Word
Dim CurrentChannel As Byte
Dim bNextchannel As Byte
Dim itm As Byte
Dim iDa As Byte
Dim iDb As Byte
Dim iDc As Byte
Dim iDd As Byte
Dim iTa As Byte
Dim iTb As Byte
Dim iTc As Byte
Dim iTd As Byte
Dim bADCResult(3) As Byte
Dim bREGa(254) As Byte
Dim bREGb(254) As Byte
Dim bREGc(254) As Byte
Dim bREGd(254) As Byte
Dim dTempdatum(1) As Byte
Dim dTempresult As Word
Dim iError As Integer
Dim wError As Word

Dim IsTempresultSense As Byte
Dim iErrcode As Byte
Dim iKeypress As Byte
Dim iKeycode As Word


Dim Vsetm As Word		' The Master DAC Setting Return
Dim Vsets As Word		' The Slave  DAC Setting Return
Dim mbMSB As Byte
Dim mbLSB As Byte	
Dim sbMSB As Byte
Dim sbLSB As Byte

Dim bChbStart As Byte
Dim bChbEnd As Byte
Dim bChcStart As Byte
Dim bChcEnd As Byte
Dim iHardwareInit As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Float Variables
'///////////////////////////////////////////////////////////////////////////////////////////////////
Dim fTrn As Float
Dim fOut As Float
Dim fGndOffset As Float
Dim fReference As Float
Dim fSynthesis As Float
Dim fCalsacles As Float
Dim fCalfSynth As Float
Dim fSetting As Float
Dim fVoltage As Float
Dim fError As Float
Dim fVset As Float
Dim fDefslave As Float
Dim fVtrn As Float
Dim fTemperature As Float
Dim Vseth As Word
Dim Vsetl As Word
'///////////////////////////////////////////////////////////////////////////////////////////////////
										' Screen Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Function WriteKS(Code As Byte, Channel As Byte) As Byte				' ʾдݵĺ
Declare Function SetKS(Code As Byte, Channel As Byte) As Byte				' ʾдָĺ
Declare Function InitKS() As Byte											' ʼʾ
Declare Function ResetKS() As Byte											' ʾϵ纯Ӳ·
Declare Function ClsKS(GRAM As Byte) As Byte								' 
Declare Function DrawPix(x As Byte, y As Byte) As Byte						' ʾϻһ
Declare Function DrawPage(x As Byte, Page As Byte, Code As Byte) As Byte	' ʾϻһҳ
Declare Function DrawChr(x As Byte, Page As Byte) As Byte					' ʾһб׼ ASCII ַ
Declare Function DrawChrLarge(x As Byte, Page As Byte) As Byte					' ʾһб׼ ASCII ַ
Declare Function DrawCursors(x As Byte, Page As Byte, Length As Byte) As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
										' IO Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Function WriteSReg(bDat As Byte) As Byte
Declare Function WriteSBUS(bDat As Byte) As Byte
Declare Function WriteDAC(bmDath As Byte, bmDatL As Byte, bsDath As Byte, bsDatL As Byte) As Byte
Declare Function SetChannel(Channel As Byte) As Byte
Declare Function ReadADC() As Byte
Declare Function ReadKEY() As Byte

Declare Function ReadSPI() As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Mathematical Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Function SetVoltage(fVoltage As Float) As Byte
Declare Function Getinlerr(fVoltage As Float) As Float

Declare Function ReadADConvert(NextChannel As Byte) As Long
Declare Function FixADCResult() As Byte
Declare Function WriteResultREG(bSetp As Byte, bArea As Byte) As Byte 
Declare Function MoveResultREG(bSetp As Byte, bArea As Byte) As Byte 
Declare Function ReadADCResult(bChannel As Byte) As Float

Declare Function ReadADCResultMax(bChannel As Byte) As Float
Declare Function ReadADCResultMin(bChannel As Byte) As Float

Declare Sub StatusDisplay()
Declare Function UpdateTempresultInfo() As Byte
Declare Sub Trigcompleted()
Declare Function ADCheck(bNextChannel As Byte) As Integer

Declare Function Selftest() As Byte
Declare Function Debug(iTestcode As Byte) As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' UART Interrupt
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Interrupt Urxc()
Declare Interrupt Int0()
'************** Enable the Keyboard **************
'Int0 Rising 'Falling '
Enable Interrupts
'Enable Int0
'************** Enable the Keyboard **************						
'Enable Interrupts
Enable Urxc

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Config the MCU IO Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
DDRA = &b11111111		'Display Screen Data Bus
							'Parallel 8bit Data bus
DDRC = &b11111111		'Display Screen Control Bus
							'PC0: (Saved)
							'PC1: (Saved)
							'PC2: Screen Strobe
							'PC3: Screen Write or Read
							'PC4: Screen Data or Instructions
							'PC5: Screen Area Enable LO Bit
							'PC6: Screen Area Enable HI Bit
							'PC7: Screen Reset
DDRB = &b10110111		'Analog Board Connect
							'REG STB <--- PB0 
							'REG DAT <--- PB1
							'REG CLK <--- PB2
							'ADC CLK <--- PB3
							'ADC DAT ---> PB4
							'KEY STB <--- PB5
							'KEY DAT ---> PB6
							'KEY CLK <--- PB7
DDRD = &b11111011		'INT, UART and PWM Control
							'PD0: UART RX
							'PD1: UART TX
							'PD2: INT0 TRIG(Key)
							'PD3: INT1 TRIG(Saved)
							'PD4: PWM OC1B(Saved)
							'PD5: PWM OC1A(Saved)
							'PD6: 1Wire BUS(DS18b20)
							'PD7: PWM OC2(Saved)		
PORTA = &b00000000						
PORTB = &b01000000
PORTC = &b00000000
PORTD = &b00000000
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Program Initialization
'///////////////////////////////////////////////////////////////////////////////////////////////////						
' Analog Board Initialization, Open all Analog Switch
bSregister = &b00000000							'Setting the ADC to Power Down

WriteSBUS(&b11111111) : WriteSBUS(&b11111111) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
'Wait 5
bSregister = &b00010000							'Setting the ADC to Power Up
WriteSBUS(&b11111111) : WriteSBUS(&b11111111) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
'Wait 5
SetVoltage(0)
InitKS()				' ʼʾ
ClsKS(0)				' 
' LCD Test and Init Display Charat
			Charat = "Voltage Generator" : DrawChrLarge(6,1)
			Charat = "Version 1.0" : DrawChr(32,3)
			Charat = "Build 173" : DrawChr(44,4)
			Charat = "By Lilith Washu" : DrawChr(38,6)

Wait 2					'Wait the LM399 Initialization
ClsKS(0)
Charat = "Initialization" : DrawChr(1,0)
'Initialization Var?

Charat = "Initialization     OK" : DrawChr(1,0)
iKeypress = 0
iKeycode = 0
iHardwareInit = 3					'Hardware Initialization(Power Up)
bErrlimit = 5
wErrlimit = bErrlimit * bErrlimit

'///////////////////////////////////////////////////////////////////////////////////////////////////
									' EEPROM Initialization
'///////////////////////////////////////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Self Test
'///////////////////////////////////////////////////////////////////////////////////////////////////
iErrcode = Selftest()
If iErrcode > 1 Then
	Charat = "Failed" : DrawChr(91,1)
	Charat = "Code:" : DrawChr(1,7)
	Format(3,0) : Charat = Str(iErrcode) : DrawChr(31,7)
	'SetChannel(Synthesis)
	Wait 5
	'End
	Debug(iErrcode)
Else
	Charat = "OK" : DrawChr(115,1)
	Wait 5
End If

'WriteDAC(255,255,255,255)
'End

'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Self Test End
'///////////////////////////////////////////////////////////////////////////////////////////////////



'Wait 1	'Wait the LM399 Warmed
ClsKS(0)
' Screen Fixed Display Initialization
			Charat = "SET:"
			DrawChrLarge(1,0)
			Charat = "REB:"
			DrawChrLarge(1,2)
			Charat = "VDC"
			DrawChrLarge(105,0)
			DrawChrLarge(105,2)
' Right Sataus Lable Display
			'Charat = "MH:"
			'DrawChr(156,0)
			'Charat = "ML:"
			'DrawChr(156,1)
			'Charat = "SH:"
			'DrawChr(156,2)
			'Charat = "SL:"
			'DrawChr(156,3)
			'Charat = "WAT:" : DrawChr(156,4)
			'Charat = "ADJ:"
			'DrawChr(156,5)
'Botton Sataus Label Display
			Charat = "IGN" : DrawChr(7 ,4)
			Charat = "EXE" : DrawChr(7 ,5)
			'Charat = "TemP" : DrawChr(12,6)
			'Charat = "Filt" : DrawChr(96,6)
			Charat = "ErR" : DrawChr(62,4)
			Charat = "uV" : DrawChr(116,4)
			Charat = "uV" : DrawChr(116,5)
			Charat = "AdJTh" : DrawChr(62,5)
			Charat = "TemP" : DrawChr(62,6)
			'Charat = "Len" : DrawChr(30,6)
			'Charat = "RuN" : DrawChr(100,5)
			'Charat = "StP" : DrawChr(100,4)
			
			Charat = "RuN" : DrawChr(7, 6)
			Charat = "StP" : DrawChr(7, 7)
			
			Charat = "pt"  :  DrawChr(42,6)
			Charat = "/" :  DrawChr(42,7)
			
			Charat = "CaL ZeO SmP" : DrawChr(62,7)
			'Charat = "    1st 2nd" : DrawChr(62,7)

			Charat = "INL:" : DrawChr(132,6)
						
			MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(105, 7, 4)
' Cursors Draw
			'MemLoad(VarPtr(iCursors), &b00001000, &b00011100, &b00111110, &b01111111) : DrawCursors(1, 4, 4)				' Display a "<" Cursors
			'MemLoad(VarPtr(iCursors), &b01111111, &b00111110, &b00011100, &b00001000) : DrawCursors(1, 4, 4)				' Display a ">" Cursors
			'MemLoad(VarPtr(iCursors), &b00000100, &b00000110, &b00000111, &b00000110, &b00000100) : DrawCursors(1, 4, 5) 	' Display a "^" Cursors
If IsTempresultSense = 1 Then
			MemLoad(VarPtr(iCursors), &b00000110, &b00001001, &b00001001, &b000000110) : DrawCursors(116, 6, 4)				' Display a  Degree Cursors
			Charat = "C" : DrawChr(122,6)
			UpdateTempresultInfo()
End If
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Program Initialization End
'///////////////////////////////////////////////////////////////////////////////////////////////////
' Start the Temperature Sense(DS18b20) Convert
'1Wreset
'1Wwrite &hcc; &h44
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Running  Register Initialization
'///////////////////////////////////////////////////////////////////////////////////////////////////
' Init the DAC Output Default
fSetting = 10000000
fVoltage = fSetting
' Program Reset Point:
stt:								
fVoltage = fVoltage / fDacal
SetVoltage(fVoltage)
' All Setting Register Value Initialization to Default
fReference = 0
fSynthesis = 0
fCalsacles = fMasterReference
iSmlen = 4				' the Sommth Length, 1 Trig Cycle(Adjuest Cycle) = 3 x Sommth Length
bDigitaLoop = 1			' Digital Loop = Close Loop(0=Open Loop)
itm = 0
iSmsetp = 0				' Current Program Running Setp
bRun = 1				' Flag the Program Run or Setp, 1 = Run
bRefsource = 0			' Flag the Reference Source, 0 = INT, 1 = EXT
bNextchannel = 0		' Flag the Analog Switch Channel
bAdjuest = 0			' Flag is/isnot Adjuest Output Voltage
bUartlk = 0				' Flag the UART Port Talk,bit 8 = All Talk; bit 1 = talk when Trigcompleted.
bUartset = 2
bRunacycle = 0
' Display and Update the Output Voltage Setting Value
Format(2,0)
Charat = Str(iSmlen) : DrawChr(30,6)


Format(2,5)
fTrn = fSetting / 1000000
Charat = Str(fTrn)
DrawChrLarge(28,0)


'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Program Main Loop

'///////////////////////////////////////////////////////////////////////////////////////////////////
SetChannel(Synthesis)
Do
	If bRun = 0 Then
		Charat = " --------" : DrawChrLarge(28,2)
		MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(1, 6, 4)
		MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(1, 7, 4)
		iSmsetp = 0
		bRunacycle = 0
		WaitMs 100
		GoTo Runout
	Else
		MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(1, 7, 4)
		MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(1, 6, 4)	
	End If
	
	iBusystp = 0
	Do
		iBusystp = iBusystp + 1
		WaitMs 1
	Loop While IO_ADC_DAT = 1 
	Charat = Hex(iBusystp) : DrawChr(42, 7)


	bADCResult(3) = 0
	bADCResult(2) = ReadADC()
	bADCResult(1) = ReadADC()
	bADCResult(0) = ReadADC()

	
	iDa = iDa - 128
	IO_ADC_CLK = 1 : WaitUs 1 : IO_ADC_CLK = 0
	
	iSmsetp = iSmsetp + 1
	
	bChbStart = iSmlen * 2
	bChcStart = iSmlen * 3
	Select Case iSmsetp 
			Case iSmlen
					CurrentChannel = SetChannel(Reference) 
					MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(105, 7, 4)
					MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(57, 7, 4)
			Case bChbStart
					CurrentChannel = SetChannel(GndOffset)
					MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(57, 7, 4)
					MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(81, 7, 4)
			Case bChcStart
					CurrentChannel = SetChannel(Synthesis)
					MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(81, 7, 4)
					MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(105, 7, 4)
	End Select
	
	bChbStart = iSmlen + 1
	bChbEnd = iSmlen * 2
	bChcStart = bChbEnd + 1
	bChcEnd = iSmlen * 3
	Select Case iSmsetp 
			Case 1 To iSmlen : bNextchannel = 1
			Case bChbStart To bChbEnd : bNextchannel = 2
			Case bChcStart To bChcEnd : bNextchannel = 3
	End Select
	
	
	FixADCResult()
	
	For i = 1 To iSmlen
		MoveResultREG(i, bNextchannel)
	Next i
	WriteResultREG(iSmlen, bNextchannel)
	
	
	'Format(2,0)
	Charat = Hex(iSmsetp) : DrawChr(30,7)
	
	fSynthesis = ReadADCResult(1) 'ref
	fReference = ReadADCResult(2) 'gnd
	fGndOffset = ReadADCResult(3) 'syn
	
	fCalfSynth = (fSynthesis - fGndOffset) / ((fReference - fGndOffset) / fCalsacles)
	fCalfSynth = fCalfSynth + Getinlerr(fCalfSynth)/ 1000000

	fTrn = Getinlerr(fCalfSynth)
	Format(3, 1) : Charat = Str(fTrn) : DrawChr(156, 6)
	
	fError = fSetting - fCalfSynth * 1000000
	iError = fError
	wError = iError * iError
	
	'Format(2,6)
	'Charat = Str(fCalfSynth)
	'DrawChrLarge(28,2)
		
	Format(4,0)
	Charat = "     " : DrawChr(86,4)
	Charat = Str(iError) : DrawChr(86,4)
	
	iErrlimit = 0
	If wError > wErrlimit Then iErrlimit = 1
	bAdjuest = bDigitaLoop And iErrlimit
	
	If iSmsetp = iSmlen Then
		Charat = "    " : DrawChr(30, 4)
	End If
	If iSmsetp = 5 Then
		Charat = "    " : DrawChr(30, 5)
	End If	
		
	If iSmsetp = 1 Then
		Charat = "SMPL" : DrawChr(30, 4)
		Format(2,5)
		Charat = Str(fCalfSynth) : DrawChrLarge(28,2)	
		
		If bRunacycle > 9 Then bRunacycle = 1	
		
		If bRunacycle > iHardwareInit And bAdjuest = 1 Then
			Charat = "TRIG" : DrawChr(30, 5)
			bRunacycle = 0
			Trigcompleted()
			iHardwareInit = 1
			Format(Scientific,6) : Print "#CSYN=$ "; fCalfSynth; " #CERR=$ "; fError; " #TEMP=$ "; fTemperature; " #RUNC=$ "; Hex(bRunacycle); " #ADJ=YES"
		Else
			Format(Scientific,6) : Print "#CSYN=$ "; fCalfSynth; " #CERR=$ "; fError; " #TEMP=$ "; fTemperature; " #RUNC=$ "; Hex(bRunacycle); " #ADJ=NON"
		End If		
	End If
	
	
	If iSmsetp = iSmlen * 3 Then
		bRunacycle = bRunacycle + 1
		iSmsetp = 0 
	End If
	
	Runout: 
	If bUartset = 1 Then
		bUartset = 0 
		iSmsetp = 0
		fVoltage = fSetting
		fVoltage = fVoltage / fDacal
		SetVoltage(fVoltage)
		fTrn = fSetting / 1000000
		Format(2,5)
		Charat = Str(fTrn)
		DrawChrLarge(28,0)
		bRunacycle = 0
	End If
	
	If bUartset = 2 Then
		bUartset = 0
		bRunacycle = 0
		iSmsetp = 0
		StatusDisplay()
	End If
	
	If iKeypress = 1 Then
		iKeypress = 0
		WaitMs 1
		iKeycode = ReadKey() + ReadKey() * 256
	End If
	'Charat = Hex(iKeycode) : DrawChr(1,6)
Loop
End

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Operation Sub and Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
Sub StatusDisplay()
If bDigitaLoop = 1 Then
	MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(1, 4, 4)
	MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(1, 5, 4)
Else
	MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(1, 5, 4)
	MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(1, 4, 4)
End If
Format(2,0) : Charat = Str(iSmlen) : DrawChr(30,6)
Format(2,0) : Charat = Str(bErrlimit) : DrawChr(98,5)
End Sub

Function UpdateTempresultInfo() As Byte
	1Wreset
	1Wwrite &hcc; &hbe
	1Wread dTempdatum ,2
	1Wreset
	1Wwrite &hcc; &h44
	dTempresult = dTempdatum(0)
	fTemperature = dTempresult
	fTemperature = fTemperature / 16
	Format(2,1) : Charat = Str(fTemperature) : DrawChr(86, 6)
End Function

Sub Trigcompleted()
	If bAdjuest = 1 Then
		fVoltage = fVoltage + fError
		SetVoltage(fVoltage)
	End If
	If IsTempresultSense = 1 Then UpdateTempresultInfo()
	'If bUartlk = 1 Then
		'Format(5,2)
		'Print fError; fTemperature
	'End If
End Sub

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Return the 24bit Result from 32bit Data
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function FixADCResult() As Byte
iDa = bADCResult(2)
iDa = iDa - 128
bADCResult(2) = iDa
Return 0
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Write a ADC Result to FIFO Movewindow Array
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteResultREG(bSetp As Byte, bArea As Byte) As Byte 
iTrd = (bArea - 1) * iSmlen + bSetp 
bREGa(iTrd) = bADCResult(3)
bREGb(iTrd) = bADCResult(2)
bREGc(iTrd) = bADCResult(1)
bREGd(iTrd) = bADCResult(0)
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Move the FIFO Array
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function MoveResultREG(bSetp As Byte, bArea As Byte) As Byte 
iTrd = (bArea - 1) * iSmlen + bSetp 
bREGa(iTrd) = bREGa(iTrd + 1)
bREGb(iTrd) = bREGb(iTrd + 1)
bREGc(iTrd) = bREGc(iTrd + 1)
bREGd(iTrd) = bREGd(iTrd + 1)
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Return a Float Format Smohth ADC Result 
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function ReadADCResult(bChannel As Byte) As Float
fTrn = 0
fOut = 0
For i = 1 To iSmlen
	iTrd = (bChannel - 1) * iSmlen + i
	iTa = bREGa(iTrd)
	iTb = bREGb(iTrd)
	iTc = bREGc(iTrd)
	iTd = bREGd(iTrd)
	fTrn = 2.4 + 2.5 * (65536 * iTb + 256 * iTc + iTd - 8388608) / 8388608
	fOut = fOut + fTrn
Next i
fOut = fOut / iSmlen
Return fOut
End Function


Function ReadADCResultMax(bChannel As Byte) As Float

End Function


Function ReadADCResultMin(bChannel As Byte) As Float


End Function

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Other

'///////////////////////////////////////////////////////////////////////////////////////////////////

Function DrawCursors(x As Byte, Page As Byte, Length As Byte) As Byte
For i = 0 To Length - 1
	DrawPage(x + i, Page, iCursors(i))
Next i
End Function








'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Shiftreg IO

'///////////////////////////////////////////////////////////////////////////////////////////////////



'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Wrtie the Analog board Control Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteSReg(bDat As Byte) As Byte
Local i As Byte
Local bWritedat As Byte
Local bWritebit As Byte
bWritedat = bDat
IO_REG_DAT = 0
IO_REG_CLK = 0
IO_REG_STB = 0
WaitUs 1
For i = 1 To 8
    bWritebit = bWritedat And &b10000000
    If bWritebit = 128 Then
       IO_REG_DAT = 1
    Else
       IO_REG_DAT = 0
    End If 
    WaitUs 1
    IO_REG_CLK = 1 : WaitUs 1 : IO_REG_CLK = 0
    bWritedat = Shift(Left, 1, bWritedat)  
Next i
WaitUs 1
IO_REG_STB = 1 : WaitMs 1 : IO_REG_STB = 0
IO_REG_DAT = 0
IO_REG_CLK = 0

Return 0
End Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Setting the Analog Switch(ADC Input Channel)
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function SetChannel(Channel As Byte) As Byte				
Local Channelset As Byte
Channelset = bSregister And &b11100000
'WriteSReg(Channelset)		' Open all Analog Switch when Close Next Switch
WriteSBUS(&b11111111) : WriteSBUS(&b11111111) : WriteSBUS(Channelset)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
WaitMs 10
bSregister = Channelset + Channel
bSregister = bSregister + &b00010000
'WriteSReg(bSregister)
WriteSBUS(&b11111111) : WriteSBUS(&b11111111) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
Return bSregister
End Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Wrtie the DAC Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteSBUS(bDat As Byte) As Byte
Local i As Byte
Local bWritedat As Byte
Local bWritebit As Byte
bWritedat = bDat
IO_REG_DAT = 0
IO_REG_CLK = 0
WaitUs 1
For i = 1 To 8
    bWritebit = bWritedat And &b10000000
    If bWritebit = 128 Then
       IO_REG_DAT = 1
    Else
       IO_REG_DAT = 0
    End If 
    WaitUs 1
    IO_REG_CLK = 1 : WaitUs 1 : IO_REG_CLK = 0
    bWritedat = Shift(Left, 1, bWritedat)  
Next i
WaitUs 1

IO_REG_DAT = 0
IO_REG_CLK = 0

Return 0
End Function

Function WriteDAC(bmDath As Byte, bmDatL As Byte, bsDath As Byte, bsDatL As Byte) As Byte
' Setp 1:
'bSregister = bSregister And &b00001111							'Hold the Analog Switch Status and Setting the DAC to Write Mode
'WriteSBUS(bmDath) : WriteSBUS(bmDatL) : WriteSBUS(bsDath) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Write
' Setp 2:
'bSregister = bSregister + &b10000000							'Hold the Analog Switch Status and Setting the DAC to Update
'WriteSBUS(bmDath) : WriteSBUS(bmDatL) : WriteSBUS(bsDath) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Update

'Status REG Q1 = Slave HBE
'			Q2 = Slave LBE
'			Q3 = Master HBE
'			Q4 = Master LBE
'			Q5 = Slave CS
'			Q6 = Slave LDAC
'			Q7 = Master CS
'			Q8 = Master LDAC

' Write the Master DAC 
' Set the Msster DAC 8bit MSB Bank to Write
WriteSBUS(&b10111011) : WriteSBUS(bmDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit MSB Bank
WriteSBUS(&b10111111) : WriteSBUS(bmDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Set the Msster DAC 8bit LSB Bank to Write
WriteSBUS(&b10110111) : WriteSBUS(bmDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
WriteSBUS(&b10111111) : WriteSBUS(bmDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit LSB Bank
WriteSBUS(&b00111111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Latches Transparent to Master DAC
WriteSBUS(&b11111111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0



' Write the Slave DAC 
' Set the Slave DAC 8bit MSB Bank to Write
WriteSBUS(&b11101110) : WriteSBUS(bsDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit MSB Bank
WriteSBUS(&b11101111) : WriteSBUS(bsDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Set the Slave DAC 8bit LSB Bank to Write
WriteSBUS(&b11101101) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
WriteSBUS(&b11101111) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit LSB Bank
WriteSBUS(&b11001111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Latches Transparent to Slave DAC
WriteSBUS(&b11111111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0


Return 0
End Function


'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Read Analog Board ADC Result Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function ReadADC() As Byte
Local myByte As Byte
Local i As Byte
myByte = 0
' Read 8bit = 1 Byte Result form ADC Shift-Out Register(2Wire Serial Bus ADC)
For i = 0 To 7
    IO_ADC_CLK = 1   
    Rotate(Left,1,myByte)
    myByte = myByte + IO_ADC_DAT
    WaitUs 1
    IO_ADC_CLK = 0
    WaitUs 1      
Next i
' Return 1 Byte Result to Function
Return myByte
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Read MCU Block Keyboard Status Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function ReadKey() As Byte
Local myByte As Byte
Local i As Byte
myByte = 0
' Read 8bit = 1 Byte Result form Keyboard Shift-Out Register(74HC165)
For i = 0 To 7 
    Rotate(Left,1,myByte)
    myByte = myByte + IO_KEY_DAT
    IO_KEY_CLK = 1 
    WaitUs 1
    IO_KEY_CLK = 0
    WaitUs 1      
Next i
' Return 1 Byte Result to Function
myByte = Not myByte
Return myByte
End Function

Function ReadSPI() As Byte
Local myByte As Byte
Local i As Byte
myByte = 0

For i = 0 To 7
    IO_ADC_CLK = 1   
    Rotate(Left,1,myByte)
    myByte = myByte + IO_ADC_DAT
    WaitUs 1
    IO_ADC_CLK = 0
    WaitUs 1      
Next i

Return myByte
End Function

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

									'Mathematical Function

'///////////////////////////////////////////////////////////////////////////////////////////////////



'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Setting the Analogboard DAC Output Voltage
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function SetVoltage(fVoltage As Float) As Byte
Local iSetv As Byte
' the VOut = Gain * (Vmaster * Rs + Vslave * Rm) / (Rm+Rs), Fullscale of the Vm = 5V and Vs = -5V, Gain = 2.5
fVtrn = fVoltage
fVtrn = fVtrn / fDACGain
fVset = fVtrn
iSetv = fVset
'Format(2,0) : Charat = Str(iSetv) : DrawChr(1,6)
If iSetv > 8 Then
	fDefslave = fDACHCenter
Else
	fDefslave = fDACLCenter
End If
'Get the MasteDAC Voltage Setting Value, Vm=[Vo*(Rm+Rs)+2.5*Rm]/Rs , at Default, the Slave DAC Output = -2.5V
fVtrn = (fVtrn * (fMResistance + fSResistance) - fDefslave * fMResistance) / fSResistance' : Format(2,5) : Charat = Str(fVtrn) : DrawChr(38,4)
fVtrn = fVtrn * 65535 / fDACReference							'The Master DAC(MAX541) is 16bit DAC, Fullscale = 2^16 = 65536
Vsetm = fVtrn' : Charat = Hex(Vsetm) : DrawChr(1,6)
'mbMSB = Vsetm / 256  												'Split the Setting Word to two Byte, Get the MSB Byte
mbMSB = Msb(Vsetm)
mbLSB = Vsetm - mbMSB * 256										'Split the Setting Word to two Byte, Get the LSB Byte
' Get the SlaveDAC Voltage Setting Value,Vs=[Vo*(Rm+Rs)-Vm*Rs]/Rm
fVtrn = Vsetm * fDACReference / 65535
fVtrn = (fVset * (fMResistance + fSResistance) - fVtrn * fSResistance) / fMResistance' : Format(2,4) : Charat = Str(fVtrn) : DrawChr(1,7)
fVtrn = fVtrn * 32768 / fDACReference							'The Slave DAC(MAX515) is 12bit DAC, Fullscale = 2^12 = 4096
Vsets = fVtrn
Vsets = Vsets + 32768
sbMSB = Msb(Vsets)												'Split the Setting Word to two Byte, Get the MSB Byte
sbLSB = Vsets - sbMSB * 256										'Split the Setting Word to two Byte, Get the LSB Byte
WriteDAC(mbMSB, mbLSB, sbMSB, sbLSB)

'Charat = Hex(mbMSB) : DrawChr(50,4)
'Charat = Hex(mbLSB) : DrawChr(64,4)
'Charat = Hex(sbMSB) : DrawChr(50,5)
'Charat = Hex(sbLSB) : DrawChr(64,5)
' Write the Setting to DAC
'Setp 1:
'bSregister = bSregister And &b00001111							'Hold the Analog Switch Status and Setting the DAC to Write Mode
'ShiftOut mbMSB;mbLSB;sbMSB;sbLSB;bSregister						'Write to Serial Bus
'WriteDAC(mbMSB) : WriteDAC(mbLSB) : WriteDAC(sbMSB) : WriteDAC(sbLSB) : WriteDAC(bSregister)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Write
'Setp 2:
'bSregister = bSregister + &b10000000							'Hold the Analog Switch Status and Setting the DAC to Update
'ShiftOut mbMSB;mbLSB;sbMSB;sbLSB;bSregister
'WriteDAC(mbMSB) : WriteDAC(mbLSB) : WriteDAC(sbMSB) : WriteDAC(sbLSB) : WriteDAC(bSregister)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0						'Update the Control Shift-Register, DAC tobe Update
Return 0
End Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' ADC No-line Error Adjuest
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function Getinlerr(fVoltage As Float) As Float			
fVtrn = fVoltage 
fVset = fVtrn * fVtrn * Quadratic + fVtrn * Linear + Constant
'fVset = fVtrn * fVtrn * fVtrn * Cubic + fVtrn * fVtrn * Quadratic + fVtrn * Linear + Constant
Return fVset
End Function











'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

									'INT Process

'///////////////////////////////////////////////////////////////////////////////////////////////////

Interrupt Urxc(),Save All
Local uVseth As Word
Local uVsetl As Word
'Local uMSBh As Byte
'Local uLSBh As Byte
'Local uMSBl As Byte
'Local uLSBl As Byte
Local bMSB As Byte
Local bLSB As Byte
Local bRebtype As Byte
Local bSett As Byte
InputBin tTxt

tCmd = Mid(tTxt, 1, 3)
If tCmd = "STV" Then
   tm = Mid(tTxt,4,4)
   uVseth = Val(tm)
   tm = Mid(tTxt,8,4)
   uVsetl = Val(tm)
   fVtrn = uVseth
   fVtrn = fVtrn * 10000
   fVtrn = fVtrn + uVsetl
   tm = Mid(tTxt,12,1)
   bSett = Val(tm)
   If bSett = 0 Then
      fSetting = fVtrn
      bUartset = 1  
   End If
   If bSett = 1 Then
      fCalsacles = fVtrn
      bUartset = 1
   End If
End If

If tCmd = "STS" Then
   tm = Mid(tTxt,4,1)
   If tm <> "x" Then bDigitaLoop = Val(tm)
   tm = Mid(tTxt,12,1)
   If tm <> "x" Then bRun = Val(tm)
   tm = Mid(tTxt,11,1)
   If tm <> "x" Then bRefsource = Val(tm)
   tm = Mid(tTxt,5,2)
   iSmlen = Val(tm)
   tm = Mid(tTxt,9,2)
   bErrlimit = Val(tm)
   wErrlimit = bErrlimit * bErrlimit
   bUartset = 2
End If

If tCmd = "REB" Then
   tm = Mid(tTxt,4,1)
   bRebtype = Val(tm)
   Select Case bRebtype
          Case 0 ' Readback Measure Value(0-?)
          Case 8 ' Readback Cal
          Case 9 ' Readback Setting Status 
   End Select
End If



Enable Interrupts
End Interrupt

Interrupt Int0(), Save 0
iKeypress = 1
Enable Interrupts
End Interrupt

'$Include "inc\k12864drv.bas"
$Include "inc\ks0108drv.bas"
$Include "inc\selftest1232.bas"
$Include "inc\font1.bas"
$Include "inc\font2.bas"